<template>
  <div class="app-container">
    <!--工具栏-->
    <div class="head-container">
      <div>
        <el-select v-model="searchParam._mineIndex" placeholder="所属矿山" clearable size="small" class="filter-item" style="width: 200px;">
          <el-option v-for="mine in mineList" :key="mine.index" :label="mine.name" :value="mine.index" />
        </el-select>
        <el-input v-model="searchParam.nameLike" clearable size="small" placeholder="基站名称" style="width: 200px;" class="filter-item" />
        <el-button class="filter-item" size="mini" type="success" icon="el-icon-search" @click="searchSubmit">搜索</el-button>
        <el-button class="filter-item" size="mini" type="warning" icon="el-icon-refresh-left" @click="searchParamReset">重置</el-button>
        <el-tooltip class="item" effect="dark" content="按当前查询条件导出" placement="top">
          <el-button :loading="exporting" class="filter-item" size="mini" type="info" plain icon="el-icon-download" @click="exportSubmit">导出</el-button>
        </el-tooltip>
      </div>
      <!-- <el-button class="filter-item" size="mini" type="primary" icon="el-icon-plus" @click="doAdd()">新增</el-button> -->
    </div>
    <!--弹出框1-->
    <el-dialog append-to-body :close-on-click-modal="true" :visible.sync="dialog1Show" :title="editState==1?'新增':editState==2?'修改':'查看'" width="940px">
      <el-form ref="dialog1Form" :hide-required-asterisk="!dialog1Editing" :model="dialog1Data" :rules="dialog1Rules" size="mini" label-width="180px" style="margin-right: 80px;">
        <el-row :gutter="20">
          <el-col :span="12">
            <el-form-item label="基站编码：" prop="code">
              <span v-show="!dialog1Editing">{{ dialog1Data.code }}</span>
              <el-input v-show="dialog1Editing" v-model="dialog1Data.code" :disabled="editState==2" />
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="基站名称：" prop="name">
              <span v-show="!dialog1Editing">{{ dialog1Data.name }}</span>
              <el-input v-show="dialog1Editing" v-model="dialog1Data.name" />
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="型号：" prop="model">
              <span v-show="!dialog1Editing">{{ dialog1Data.model }}</span>
              <el-input v-show="dialog1Editing" v-model="dialog1Data.model" />
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="参数：" prop="parameter">
              <span v-show="!dialog1Editing">{{ dialog1Data.parameter }}</span>
              <el-input v-show="dialog1Editing" v-model="dialog1Data.parameter" />
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="安装位置：" prop="place">
              <span v-show="!dialog1Editing">{{ dialog1Data.place }}</span>
              <el-input v-show="dialog1Editing" v-model="dialog1Data.place" />
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="生产厂家：" prop="manufacturer">
              <span v-show="!dialog1Editing">{{ dialog1Data.manufacturer }}</span>
              <el-input v-show="dialog1Editing" v-model="dialog1Data.manufacturer" />
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="X：" prop="x">
              <span v-show="!dialog1Editing">{{ dialog1Data.x }}</span>
              <el-input v-show="dialog1Editing" v-model="dialog1Data.x" />
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="Y：" prop="y">
              <span v-show="!dialog1Editing">{{ dialog1Data.y }}</span>
              <el-input v-show="dialog1Editing" v-model="dialog1Data.y" />
            </el-form-item>
          </el-col>
        </el-row>
        <el-row :gutter="20">
          <el-col :span="12">
            <el-form-item label="断电后持续工作时长（时）：" prop="lowpowerRunningHours" label-width="260px">
              <span v-show="!dialog1Editing">{{ dialog1Data.lowpowerRunningHours }}</span>
              <el-input-number v-show="dialog1Editing" v-model="dialog1Data.lowpowerRunningHours" :precision="2" :controls="false" style="width: 100%;" />
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="图片：" prop="imgFilePath">
              <div v-for="file in dialog1Data._imgFileList" v-show="!dialog1Editing" :key="file.url">
                <el-link type="primary" @click="openFile(file)">{{ file.name }}</el-link>
              </div>
              <el-upload
                v-show="dialog1Editing"
                class="upload-demo"
                action="/api/file/upload"
                multiple
                :headers="httpHeaders"
                :limit="1"
                :on-success="upFileSuccess"
                :on-remove="upFileRemove"
                :on-error="upFileError"
                :on-exceed="upFileExceed"
                :before-upload="upFileBefore"
                :on-preview="openFile"
                :file-list="dialog1Data._imgFileListShow"
              >
                <el-button size="small" type="primary">点击上传</el-button>
                <div slot="tip" class="el-upload__tip">只能上传jpg/png文件，且不超过20M</div>
              </el-upload>
            </el-form-item>
          </el-col>
        </el-row>
      </el-form>
      <div v-show="dialog1Editing" slot="footer" class="dialog-footer">
        <el-button type="text" @click="dialog1Show=false">取消</el-button>
        <el-button :loading="dialog1Saving" type="primary" @click="dialog1Submit">确认</el-button>
      </div>
    </el-dialog>
    <!--弹出框2-->
    <el-dialog append-to-body :close-on-click-modal="true" :visible.sync="dialog2Show" :title="'确认删除'" width="580px">
      <div>
        <span>确认要删除基站：</span><span style="font-weight: bold;">{{ dialog2Data.name }}</span><span>吗？</span>
      </div>
      <div slot="footer" class="dialog-footer">
        <el-button type="text" @click="dialog2Show=false">取消</el-button>
        <el-button :loading="dialog2Saving" type="primary" @click="dialog2Submit">确认</el-button>
      </div>
    </el-dialog>
    <!--表格-->
    <el-table ref="table" v-loading="searching" :data="tableData" row-key="id">
      <el-table-column :show-overflow-tooltip="true" prop="id" label="编号" width="100px" align="center" />
      <el-table-column :show-overflow-tooltip="true" prop="mineName" label="所属矿山" align="center" />
      <el-table-column :show-overflow-tooltip="true" prop="name" label="基站名称" align="center" />
      <el-table-column :show-overflow-tooltip="true" prop="code" label="基站编码" align="center" />
      <el-table-column :show-overflow-tooltip="true" prop="parameter" label="参数" align="center" />
      <el-table-column :show-overflow-tooltip="true" prop="manufacturer" label="生产厂家" align="center" />
      <el-table-column :show-overflow-tooltip="true" prop="place" label="安装位置" align="center" />
      <el-table-column :show-overflow-tooltip="true" prop="lowpowerRunningHours" label="停电后持续（时）" align="center" />
      <el-table-column label="操作" width="300px" align="center" fixed="right">
        <template slot-scope="scope">
          <el-button size="mini" round @click="doEdit(scope.row.id,false)">查看</el-button>
          <!-- <el-button size="mini" round @click="doEdit(scope.row.id,true)">修改</el-button> -->
          <!-- <el-button size="mini" round @click="doDelete(scope.row.id)">删除</el-button> -->
        </template>
      </el-table-column>
    </el-table>
    <el-pagination
      :page-sizes="[10, 20, 50, 100]"
      :current-page.sync="searchParam.page"
      :page-size.sync="searchParam.count"
      :total="searchResult.total"
      layout="total, sizes, prev, pager, next, jumper"
      @size-change="searchSubmit"
      @current-change="searchSubmit"
    />
  </div>
</template>

<script>
import iotPersonBaseStationApi from '@/api/kd/iotPersonBaseStation'
import { mapGetters } from 'vuex'
import { getToken } from '@/utils/auth'
import mineApi from '@/api/kd/mine'
import { downloadFile } from '@/utils'

const searchParam = {// 默认搜索条件
  page: 1,
  count: 10,
  searchCount: true
}
export default {
  name: 'CIotPersonBaseStation', // 本页面名
  components: {},
  data() {
    return {
      mineList: [],
      httpHeaders: {
        'Authorization': getToken()
      },
      searching: false,
      exporting: false,
      searchParam: {},
      searchResult: {
        total: 0,
        results: [] // 搜索结果
      },
      dialog1Show: false,
      dialog1Editing: false,
      dialog1Saving: false,
      dialog1Data: {},
      dialog1Rules: {
        name: [{ required: true, message: '请填写' }],
        code: [{ required: true, message: '请填写' }],
        model: [{ required: true, message: '请填写' }],
        parameter: [{ required: true, message: '请填写' }],
        place: [{ required: true, message: '请填写' }],
        manufacturer: [{ required: true, message: '请填写' }],
        x: [{ required: true, message: '请填写' }],
        y: [{ required: true, message: '请填写' }]
      },
      editState: 0, // （刚打开窗口时）记录了上次窗口作用；（保存编辑时）记录了当前窗口作用； 0无 1新增 2修改 3查看
      addingData: {}, // 上次正在新增时的内容，下次打开dialog1窗口时记录下来
      dialog2Show: false,
      dialog2Saving: false,
      dialog2Data: {}
    }
  },
  computed: {
    ...mapGetters([
      'user',
      'baseApi'
    ]),
    tableData() {
      // 此处对返回值进行算法重组
      return this.searchResult.results
    }
  },
  mounted() {
    // 矿山选项卡
    mineApi.getEnableMine().then(response => {
      let i = 1
      response.results.forEach(x => { x.index = i++ })
      this.mineList = response.results
    })
    this.searchParamReset()
    this.searchSubmit()
  },
  methods: {
    searchParamReset() {
      this.searchParam = JSON.parse(JSON.stringify(searchParam))
    },
    searchSubmit() {
      this.searching = true
      if (this.searchParam._mineIndex) {
        const mine = this.mineList[this.searchParam._mineIndex - 1]
        this.searchParam.mineType = mine.mineType
        this.searchParam.mineId = mine.id
      } else {
        this.searchParam.mineType = null
        this.searchParam.mineId = null
      }
      iotPersonBaseStationApi.getPage(this.searchParam).then(response => {
        this.searching = false
        this.searchResult = response
      }).catch(() => {
        this.searching = false
      })
    },
    exportSubmit() {
      this.exporting = true
      if (this.searchParam._mineIndex) {
        const mine = this.mineList[this.searchParam._mineIndex - 1]
        this.searchParam.mineType = mine.mineType
        this.searchParam.mineId = mine.id
      } else {
        this.searchParam.mineType = null
        this.searchParam.mineId = null
      }
      iotPersonBaseStationApi.export(this.searchParam).then(response => {
        downloadFile(response, '人员定位基站', 'xlsx')
        this.exporting = false
      }).catch(() => {
        this.exporting = false
      })
    },
    dialog1Submit() {
      this.$refs['dialog1Form'].validate(valid => {
        if (!valid) {
          return
        } else {
          this.dialog1Saving = true
          if (this.dialog1Data._imgFileList) {
            this.dialog1Data.imgFilePath = JSON.stringify(this.dialog1Data._imgFileList)
          }
          if (this.editState === 1) { // 新增
            // TODO 矿山
            iotPersonBaseStationApi.add(this.dialog1Data).then(() => {
              this.dialog1Show = false
              this.$message.success('保存成功')
              setTimeout(() => { // 立即清除会导致输入框Validate一闪变红
                this.dialog1Data = {}
                this.dialog1Data._imgFileListShow = []
                this.dialog1Saving = false
              }, 500)
              this.searchSubmit()
            }).catch(() => {
              this.dialog1Saving = false
            })
          } else if (this.editState === 2) { // 修改
            iotPersonBaseStationApi.set(this.dialog1Data).then(() => {
              this.dialog1Show = false
              this.$message.success('修改成功')
              setTimeout(() => { // 立即清除会导致输入框Validate一闪变红
                this.dialog1Data = {}
                this.dialog1Data._imgFileListShow = []
                this.dialog1Saving = false
              }, 500)
              this.searchSubmit()
            }).catch(() => {
              this.dialog1Saving = false
            })
          } else {
            this.$message.error('出错啦，请重试')
            this.dialog1Saving = false
          }
        }
      })
    },
    beforeDialog1Open() { // 窗口打开前的统一操作
      if (this.editState === 1) {
        this.addingData = this.dialog1Data
      }
    },
    doAdd() {
      this.beforeDialog1Open()
      this.editState = 1
      this.dialog1Editing = true
      this.dialog1Data = this.addingData // 初始值：上次编辑的内容
      this.dialog1Show = true
      this.$nextTick(() => {
        this.$refs['dialog1Form'].clearValidate()
      })
    },
    doEdit(id, isEdit) {
      this.beforeDialog1Open()
      this.editState = isEdit ? 2 : 3
      iotPersonBaseStationApi.getById(id).then(response => {
        this.dialog1Data = response
        if (this.dialog1Data.imgFilePath) {
          this.dialog1Data._imgFileList = JSON.parse(this.dialog1Data.imgFilePath)
          this.dialog1Data._imgFileListShow = JSON.parse(this.dialog1Data.imgFilePath) // 数据存放与原始绑定分开，可以防止中途赋值产生的闪烁问题
        }
        this.dialog1Editing = isEdit
        this.dialog1Show = true
        this.$nextTick(() => {
          this.$refs['dialog1Form'].clearValidate()
        })
      }).catch(() => {
        this.searchSubmit()
      })
    },
    dialog2Submit() {
      this.dialog2Saving = true
      iotPersonBaseStationApi.del(this.dialog2Data).then(() => {
        this.dialog2Show = false
        this.$message.success('删除成功')
        this.dialog2Data = {}
        this.dialog2Saving = false
        this.searchSubmit()
      }).catch(() => {
        this.dialog2Saving = false
      })
    },
    doDelete(id) {
      iotPersonBaseStationApi.getById(id).then(response => {
        this.dialog2Data = response
        this.dialog2Show = true
      }).catch(() => {
        this.searchSubmit()
      })
    },
    upFileSuccess(response, file, fileList) {
      if (!this.dialog1Data._imgFileList) {
        this.dialog1Data._imgFileList = []
      }
      this.dialog1Data._imgFileList.push({
        name: file.name,
        url: response.result
      })
    },
    upFileError() {
      this.$message.error('上传失败，请稍后再试')
    },
    upFileRemove() {
      this.$set(this.dialog1Data, '_imgFileList', [])
    },
    upFileBefore(file) {
      const isIMG = file.type === 'image/jpeg' || file.type === 'image/png'
      const isLtSize = file.size / 1024 / 1024 < 20
      if (!isIMG) {
        this.$message.error('上传图片只能是 JPG/JPEG/PNG 格式')
        return false
      }
      if (!isLtSize) {
        this.$message.error('上传图片大小不能超过 20MB')
        return false
      }
      return true
    },
    upFileExceed() {
      this.$message.error('您已经上传了一张图，请删除后重新上传')
    },
    openFile(file) {
      if (file.url) {
        window.open(this.baseApi + '/file' + file.url)
      } else if (file.response && file.response.result) {
        window.open(this.baseApi + '/file' + file.response.result)
      }
    }
  }
}
</script>

<style rel="stylesheet/scss" lang="scss" scoped>
  ::v-deep .el-input-number .el-input__inner {
    text-align: left;
  }
  ::v-deep .vue-treeselect__control,::v-deep .vue-treeselect__placeholder,::v-deep .vue-treeselect__single-value {
    height: 30px;
    line-height: 30px;
  }
</style>
